/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
   * The contents of this file are subject to the Mozilla Public
   * License Version 1.1 (the "License"); you may not use this file
   * except in compliance with the License. You may obtain a copy of
   * the License at http://www.mozilla.org/MPL/
   * 
   * Software distributed under the License is distributed on an "AS
   * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   * implied. See the License for the specific language governing
   * rights and limitations under the License.
   * 
   * The Original Code is mozilla.org code.
   * 
   * The Initial Developer of the Original Code is Netscape
   * Communications Corp.  Portions created by Netscape are
   * Copyright (C) 2001 Netscape Communications Corp.  All
   * Rights Reserved.
   * 
   * Contributor(s):
   *   Adrian Mastronardi <adrianm@museo.fcnym.unlp.edu.ar>
   */

/**** - Search function's - ***************************************************/
function pmtDoSearch(pmtOpenSearchIn) {
	var pmtQuery = document.getElementById('pmtQueryExpression').value;
	if(!pmtQuery) { return; }
	
	var url = "";
	var cgi_to_run = "";
	var parm_to_cgi = "";
	var search_for = document.getElementById('pmtDatabase').value; //database or service to search

	switch (search_for) {
	case 'JournalBrowser':
				url = "http://www.ncbi.nlm.nih.gov/entrez/";
				cgi_to_run = "jrbrowser.cgi?";
				parm_to_cgi = "field=0&dispmax=20&dispstart=0&regexp=" + document.getElementById('pmtQueryExpression').value;
				break;
	case 'MeSHBrowser':
		url = "http://www.ncbi.nlm.nih.gov/entrez/";
		cgi_to_run = "meshbrowser.cgi?";
		parm_to_cgi = "retrievestring=&term=" + document.getElementById('pmtQueryExpression').value + "&mbdetail=n";
		break;
	case 'MedlinePlus':
		url = "http://wwwindex.nlm.nih.gov/cgi/";
		cgi_to_run = "htsearch?";
		parm_to_cgi = "words=" + document.getElementById('pmtQueryExpression').value + "&config=medplus%5Ffuzzy" + "&method=and" + "&format=builin%2Dshort" + "&restric=" + "&search_type=All%20MEDLINEplus";
		break;
	case 'ClinicalTrials.gov':
		url = "http://clinicaltrials.gov/ct/gui/c/w2b/screen/OpeningScreen/action/";
		cgi_to_run = "SearchAction?";
		parm_to_cgi = "JServSessionIdzone_ct=gcwtr2m7v1&Term=" + document.getElementById('pmtQueryExpression').value;
		break;
	case 'PubMedCentral':
		url = "http://www.pubmedcentral.nih.gov/";
		cgi_to_run = "tocrender.fcgi?";
		parm_to_cgi = "action=search&terms=" + document.getElementById('pmtQueryExpression').value + "&startpage=1";
		break;
    	default :
		url = "http://www.ncbi.nlm.nih.gov/entrez/";
		cgi_to_run = "query.fcgi?";
		parm_to_cgi = "cmd=search&db=" + document.getElementById('pmtDatabase').value + "&term=" + document.getElementById('pmtQueryExpression').value;
	}

	var pmtQueryBox = document.getElementById("pmtQueryExpression");
	pubmedbarAddTerm(pmtQueryBox.value);

	//alert("Comando a correr: "+url+cgi_to_run+parm_to_cgi);

	// Launch search
	switch(pmtOpenSearchIn) {
	case 0 :	// launch search in this window
		_content.location.href = url+cgi_to_run+parm_to_cgi;
		break;
	case 1 :	// launch search in new tab
		var browser = getBrowser();
		var tab = browser.addTab(url+cgi_to_run+parm_to_cgi);
		break;
	case 2 :	// launch search in new window
		open(url+cgi_to_run+parm_to_cgi);
		break;
	default :
		_content.location.href = url+cgi_to_run+parm_to_cgi;
	}
}

function pmtHandleKeyEvent(inEvent) {	//Contributed by EasySearch project developers
	if(inEvent.keyCode == 13) {
		//default 0 = this window
		var pmtSearchWType = 0;

		//if ctrl set = 1 = in tab
		if(inEvent.ctrlKey) {
			pmtSearchWType = 1;
		}

		//if shift set = 2 = in new window
		if(inEvent.shiftKey) {
			pmtSearchWType = 2;
		}

		pmtDoSearch(pmtSearchWType);
	}
}

function pmtDoClear() {
	document.getElementById('pmtQueryExpression').value = "";
	pmtDoEnabling();
}

function pmtDoEnabling() {
	var pmtQueryButton = document.getElementById("pmtQueryButton");
	var pmtQueryExpression = document.getElementById("pmtQueryExpression");
	pmtQueryButton.disabled = !pmtQueryExpression.value;
}


/**** - History function's - **************************************************/
function pubmedbarAddTerm(query) {
	var myMenuItem = document.createElement("menuitem");
	myMenuItem.setAttribute("label", query);
	var queryBox = document.getElementById("pmtQueryExpression");
	queryBox.childNodes.item(0).appendChild(myMenuItem);
}


/**** - pmtGoMenuX function's - ***********************************************/
 /**
 * The menu option pubmed-Cubby can't passed using oncommand="window._content..."
 * because there are a & char in URL and XUL take it as entity
 **/
function pmtGoMenuCubby() {
	_content.location.href = "http://www.ncbi.nlm.nih.gov/entrez/login.fcgi?call=so.SignOn..Login";
}

function pmtGoMenuHelp() {
	alert("Sorry, this toolbar is under construction...");
}

function pmtGoMenuAbout() {
	window.openDialog("chrome://pubmed/content/about.xul","showmore","chrome,centerscreen");
}

function pmtGoMenuUpdateToolbar() {
	_content.location.href = "http://pubmed.mozdev.org";
}

